// test_system_tb.v

// Generated using ACDS version 18.0 614

//`timescale 1 ps / 1 ps
`timescale 1 ns / 100 ps
module test_system_tb (
	);

	wire    test_system_inst_clk_bfm_clk_clk;       // test_system_inst_clk_bfm:clk -> [test_system_inst:clk_clk, test_system_inst_reset_bfm:clk]
	wire    test_system_inst_reset_bfm_reset_reset; // test_system_inst_reset_bfm:reset -> test_system_inst:reset_reset_n


	wire	[19:0]	tb_avmm_addr_o;
	wire	[1:0]	tb_avmm_be_o;
	wire		tb_re_o;
	reg	[15:0]	tb_rdata_i;
	wire		tb_we_o;
	wire [15:0]	tb_wdata_o;
	reg		tb_waitreq;

	reg 		tb_ext_montr_i;
	wire [15:0]	tb_ext_montr_d_o;
	wire [1:0]	tb_ext_montr_o;


	test_system test_system_inst (
		.clk_clk                        (test_system_inst_clk_bfm_clk_clk),       //                clk.clk
		.m_master_cmp_avmm_ept_address     (tb_avmm_addr_o),                         // m_mstr_cmp_avm_ept.address
		.m_master_cmp_avmm_ept_byteenable  (tb_avmm_be_o),                           //                   .byteenable
		.m_master_cmp_avmm_ept_read        (tb_re_o),                                //                   .read
		.m_master_cmp_avmm_ept_readdata    (tb_rdata_i),                             //                   .readdata
		.m_master_cmp_avmm_ept_write_n     (tb_we_o),                                //                   .write_n
		.m_master_cmp_avmm_ept_writedata   (tb_wdata_o),                             //                   .writedata
		.m_master_cmp_avmm_ept_waitrequest (tb_waitreq),                             //                   .waitrequest
		.m_master_cmp_cdt_ept_export_0    (tb_ext_montr_i),                         // m_mstr_cmp_cdt_ept.export_0
		.m_master_cmp_cdt_ept_export_1    (tb_ext_montr_d_o),                       //                   .export_1
		.m_master_cmp_cdt_ept_export_2    (tb_ext_montr_o),                         //                   .export_2
		.reset_reset_n                  (test_system_inst_reset_bfm_reset_reset)  //              reset.reset_n
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (50000000),
		.CLOCK_UNIT (1)
	) test_system_inst_clk_bfm (
		.clk (test_system_inst_clk_bfm_clk_clk)  // clk.clk
	);

	altera_avalon_reset_source #(
		.ASSERT_HIGH_RESET    (0),
		.INITIAL_RESET_CYCLES (50)
	) test_system_inst_reset_bfm (
		.reset (test_system_inst_reset_bfm_reset_reset), // reset.reset_n
		.clk   (test_system_inst_clk_bfm_clk_clk)        //   clk.clk
	);


initial begin

	tb_ext_montr_i = 1'b1;
	tb_waitreq = 1'b1;
	tb_rdata_i = 16'h0000;
	
	#1000;
	#100 tb_waitreq = 1'b0;
	     tb_rdata_i = 16'h0001;
	#100 tb_ext_montr_i = 1'b0;
	#1000	tb_rdata_i = 16'h0002;
	#1000	tb_rdata_i = 16'h0003;
	#1000	tb_rdata_i = 16'h0004;
	#1000	tb_rdata_i = 16'h0005;
	#1000	tb_rdata_i = 16'h0006;
	#1000	tb_rdata_i = 16'h0007;
	#1000	tb_rdata_i = 16'h0008;
	#3000;
	tb_waitreq = 1'b1;
	#3000;

end

endmodule

