// test_system_tb.v

// Generated using ACDS version 18.0 614

//`timescale 1 ps / 1 ps
`timescale 1 ns / 100 ps
module test_system_tb (
	);

	wire    test_system_inst_clk_bfm_clk_clk;       // test_system_inst_clk_bfm:clk -> [test_system_inst:clk_clk, test_system_inst_reset_bfm:clk]
	wire    test_system_inst_reset_bfm_reset_reset; // test_system_inst_reset_bfm:reset -> test_system_inst:reset_reset_n

	wire	[15:0]	tb_export_o;
	wire		tb_st_snk_ready_o;
	reg		tb_st_snk_valid_i;
	reg	[15:0]	tb_st_snk_data_i;
	reg		tb_st_snk_sop_i;
	reg		tb_st_snk_eop_i;

	test_system test_system_inst (
		.clk_clk                             (test_system_inst_clk_bfm_clk_clk),       //                   clk.clk
		.reset_reset_n                       (test_system_inst_reset_bfm_reset_reset), //                 reset.reset_n
		.st_sink_cmp_cdt_expt_export_0       (tb_export_o),                                       //  st_sink_cmp_cdt_expt.export_0
		.st_sink_cmp_sink_expt_ready         (tb_st_snk_ready_o),                                       // st_sink_cmp_sink_expt.ready
		.st_sink_cmp_sink_expt_valid         (tb_st_snk_valid_i),                                       //                      .valid
		.st_sink_cmp_sink_expt_data          (tb_st_snk_data_i),                                       //                      .data
		.st_sink_cmp_sink_expt_startofpacket (tb_st_snk_sop_i),                                       //                      .startofpacket
		.st_sink_cmp_sink_expt_endofpacket   (tb_st_snk_eop_i)                                        //                      .endofpacket
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (50000000),
		.CLOCK_UNIT (1)
	) test_system_inst_clk_bfm (
		.clk (test_system_inst_clk_bfm_clk_clk)  // clk.clk
	);

	altera_avalon_reset_source #(
		.ASSERT_HIGH_RESET    (0),
		.INITIAL_RESET_CYCLES (50)
	) test_system_inst_reset_bfm (
		.reset (test_system_inst_reset_bfm_reset_reset), // reset.reset_n
		.clk   (test_system_inst_clk_bfm_clk_clk)        //   clk.clk
	);

initial begin
	tb_st_snk_valid_i = 1'b0;
	tb_st_snk_sop_i = 1'b0;
	tb_st_snk_eop_i = 1'b0;
	tb_st_snk_data_i = 16'h0000;
	#1000
	#500	tb_st_snk_sop_i = 1'b1;
		tb_st_snk_data_i = 16'h0001;
		tb_st_snk_valid_i = 1'b1;

	#20	tb_st_snk_sop_i = 1'b0;
		tb_st_snk_data_i = 16'h0002;
	#20	tb_st_snk_data_i = 16'h0003;
	#20	tb_st_snk_data_i = 16'h0004;
	#20	tb_st_snk_data_i = 16'h0005;
	#20	tb_st_snk_data_i = 16'h0006;
	#20	tb_st_snk_data_i = 16'h0007;
	#20	tb_st_snk_data_i = 16'h0008;
	#20	tb_st_snk_data_i = 16'h0009;
	#20	tb_st_snk_data_i = 16'h000a;
	#20	tb_st_snk_data_i = 16'h000b;
	#20	tb_st_snk_data_i = 16'h000c;
	#20	tb_st_snk_data_i = 16'h000d;
		tb_st_snk_eop_i = 1'b1;
	#20	tb_st_snk_eop_i = 1'b0;
		tb_st_snk_data_i = 16'h0000;
		tb_st_snk_valid_i = 1'b0;
end

endmodule
