// test_system_tb.v

// Generated using ACDS version 18.1 625

//`timescale 1 ps / 1 ps
`timescale 1 ns / 100 ps
module test_system_tb (
	);

	wire    test_system_inst_clk_bfm_clk_clk;       // test_system_inst_clk_bfm:clk -> [test_system_inst:clk_clk, test_system_inst_reset_bfm:clk]
	wire    test_system_inst_reset_bfm_reset_reset; // test_system_inst_reset_bfm:reset -> test_system_inst:reset_reset_n

	reg tb_ext_rst_i;

	reg		tb_ready_i;
	wire		tb_avst_src_valid_o;
	wire	[15:0]	tb_avst_src_data_o;
	wire		tb_avst_src_sop_o;
	wire		tb_avst_src_eop_o;

	reg 		tb_ext_montr_i;
	wire [15:0]	tb_ext_montr_d_o;
	wire [1:0]	tb_ext_montr_o;


	test_system test_system_inst (
		.clk_clk                       (test_system_inst_clk_bfm_clk_clk),       //                 clk.clk
		.reset_reset_n                 (test_system_inst_reset_bfm_reset_reset), //               reset.reset_n
		.st_src_cmp_cdt_expt_export_1  (tb_ext_montr_d_o),                                       // st_src_cmp_cdt_expt.export_1
		.st_src_cmp_cdt_expt_export_0  (tb_ext_montr_i),                                       //                    .export_0
		.st_src_cmp_cdt_expt_export_2  (tb_ext_montr_o),                                       //                    .export_2
		.st_src_cmp_expt_ready         (tb_ready_i),                                       //     st_src_cmp_expt.ready
		.st_src_cmp_expt_valid         (tb_avst_src_valid_o),                                       //                    .valid
		.st_src_cmp_expt_data          (tb_avst_src_data_o),                                       //                    .data
		.st_src_cmp_expt_startofpacket (tb_avst_src_sop_o),                                       //                    .startofpacket
		.st_src_cmp_expt_endofpacket   (tb_avst_src_eop_o)                                        //                    .endofpacket
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (50000000),
		.CLOCK_UNIT (1)
	) test_system_inst_clk_bfm (
		.clk (test_system_inst_clk_bfm_clk_clk)  // clk.clk
	);

	altera_avalon_reset_source #(
		.ASSERT_HIGH_RESET    (0),
		.INITIAL_RESET_CYCLES (50)
	) test_system_inst_reset_bfm (
		.reset (test_system_inst_reset_bfm_reset_reset), // reset.reset_n
		.clk   (test_system_inst_clk_bfm_clk_clk)        //   clk.clk
	);

initial begin
	tb_ready_i = 1'b0;
	#500	tb_ready_i = 1'b1;
	#1000;
	#100 tb_ext_montr_i = 1'b0;
	
	#3000;
	#100 tb_ready_i = 1'b0;
	#9000;
	#100 tb_ready_i = 1'b1;
	#600
	#100 tb_ready_i = 1'b1;

end

endmodule
